<!-- markdownlint-configure-file { "MD024":  { "siblings_only": true }, "MD004": { "style": "sublist" } } -->
# Changes

## CAD Exchanger Web Toolkit 3.15.0 and later

Since 3.15.0 Web Toolkit's changelog is published as part of CAD Exchanger SDK changelog, which can be found at https://download.cadexchanger.com/CHANGES.txt

## CAD Exchanger Web Toolkit 1.2.7, November 14, 2022

### Features

- Expanded the API with semantic PMI

## CAD Exchanger Web Toolkit 1.2.6, September 6, 2022

### Features

- Added methods to query Id of B-Rep shapes and vice versa
- Added ability to select/deselect B-Rep shapes on scene programmatically

### Bug fixes

- Fixed visual object selection on wireframe display mode enabled
- Fixed colors of visual objects in wireframe display mode

## CAD Exchanger Web Toolkit 1.2.5, Jul 8, 2022

### Features

- Added support of custom annotation direction and elevation for distance dimension
- Added ability to set font size for dimensions

### Bug fixes

- Fixed blurred view cube on some screens
- Fixed dimension text rendering ignoring z-buffer
- Fixed typescript definitions

## CAD Exchanger Web Toolkit 1.2.4, May 27, 2022

### Bug fixes

- Fixed clip plane capping rendering
- Fixed clip plane capping appearance setting
- Fixed position calculating of clip plane controls
- Fixed typescript definitions

## CAD Exchanger Web Toolkit 1.2.3, May 23, 2022

### Features

- Updated License Agreement file

### Bug fixes

- Fixed Box visual object displaying
- Fixed rendering on High DPI displays
- Fixed typescript definitions

## CAD Exchanger Web Toolkit 1.2.2, May 11, 2022

### Bug fixes

- Fixed Shape and Edge intersection detection
- Fixed typescript definitions

## CAD Exchanger Web Toolkit 1.2.1, April 25, 2022

### Bug fixes

- Fixed Wire, Solid, Shell intersection detection
- Fixed rendering and intersection detection for scaled parts
- Fixed typescript definitions
- Added console warning when chosen selection mode is unavailable for current model
- Examples
  * Fixed vertex coords printing in 'selectionhandling' example

## CAD Exchanger Web Toolkit 1.2.0, April 13, 2022

### Features

- Added support of B-Rep entities: solids, shells, faces, wires, edges and vertices; these can be stored in CDXFB models using CAD Exchanger SDK 3.11.0 or later
- Added support of multiple appearances in poly vertex sets
- Added readonly 'transformation' property to visual object
- Changed selection event: now it contains non-transformed shapes
- Added new selection modes aligned with B-Rep shape types
- Enabled highlighting of visual objects according to the selection mode
- Reduced WebGL memory usage
- WebGL memory is now being disposed when visual object is removed from scene
- Improved clip plane rendering
- Examples
  * Enabled new selection modes in 'selectionhandling' example
  * Ported 'measurements' example to updated selection event behavior
  * Added B-Rep entities exploration to 'modelexplorer' example
  * Enabled auto fit-all on model displaying in 'treeview' and 'selectionhandling' examples
  * Updated 'three.js' example: enabled on-demand rendering and added fit-all after model displaying
  * Updated 'sectioning' example
  * Updated list of pre-prepared models

## CAD Exchanger Web Toolkit 1.1.28, March 29, 2022

### Features

- Added 'isEqual' method for Appearance, MaterialObject and ColorObject

### Bug fixes

- Fixed clip plane updating

## CAD Exchanger Web Toolkit 1.1.27, March 18, 2022

### Bug fixes

- Fixed clip plane dragging in the viewer
- Added missed clip plane event declarations in d.ts file
- Fixed the unhandled exception happened when visual object cannot be created
- Examples
  * Updated 'sectioning' example

## CAD Exchanger Web Toolkit 1.1.26, March 14, 2022

### Features

- Added 'clip plane' feature. With it, users can add clip planes to the scene, slicing the model in half and exposing its inner structure, as well as position clip planes by specifying their precise positions or dragging them in the viewer
- Examples
  * Added 'sectioning' example, which demonstrates how to create multiple clip planes for any models
- Documentation:
  * Added page with 'sectioning' example demonstration

## CAD Exchanger Web Toolkit 1.1.25, February 24, 2022

### Bug fixes

- Actualized Readme.md

## CAD Exchanger Web Toolkit 1.1.24, February 16, 2022

### Bug fixes

- Fixed 'TS8020' error generated by d.ts file
- Added missed ModelData_IndexedTriangleSet#uvCoordinates declaration in d.ts file

## CAD Exchanger Web Toolkit 1.1.23, January 31, 2022

### Features

- Added optional vertex detection for Poly representations
- Examples:
  * Enabled polygonal models in 'measurements' and 'selectionhandling' examples

### Bug fixes

- Fixed ModelPrs_Scene#globalDisplayMode behavior
- Fixed display mode and ghost mode switching
- Fixed ignoring hidden vertices on highlight and selection

## CAD Exchanger Web Toolkit 1.1.22, January 26, 2022

### Features

- Added displayAll() method for scene to display all hidden visual objects on the scene
- Examples:
  * Added ability to select and delete measurements in 'measurements' example

### Bug fixes

- Fixed hiding and removing visual objects from the scene
- Fixed uncaught exception on touch events

## CAD Exchanger Web Toolkit 1.1.21, November 17, 2021

### Bug fixes

- Fixed bounding box calculation for view3d objects contain poly-lines and points

## CAD Exchanger Web Toolkit 1.1.20, October 12, 2021

### Bug fixes

- Fixed typescript definitions

## CAD Exchanger Web Toolkit 1.1.19, September 28, 2021

### Bug fixes

- Fixed wireframe colors

## CAD Exchanger Web Toolkit 1.1.18, July 05, 2021

### Features

- Examples:
  * Ported advanced viewer example to 'web-toolkit' npm package

### Bug fixes

- Fixed clip plane selection color

## CAD Exchanger Web Toolkit 1.1.17, July 04, 2021

### Bug fixes

- Fixed typescript definitions

## CAD Exchanger Web Toolkit 1.1.16, July 03, 2021

### Features

- Added 'exploded view' feature, which allows to display an assembly with components separated
- Examples
  * Added 'cdxfbconverter' example, which converts a CAD file to CDXFB format using CAD Exchanger SDK
  * Added 'exploder' example, which demonstrates how to create an exploded view for any models.
- Documentation:
  * Added page about preparing CDXFB model with CAD Exchanger SDK
  * Added page with 'exploder' example demonstration
  * Added section about web-toolkit integration via NPM

## CAD Exchanger Web Toolkit 1.1.15, June 21, 2021

### Features

- Published 'web-toolkit' package in npm
- Documentation:
  * Removed 'cadex' namespace

## CAD Exchanger Web Toolkit 1.1.14, March 31, 2021

### Features

- Added Marker support, which tracks the world and canvas coordinates.
- Added Annotation support, which represents Marker with label attached to it
- Added ability to pick scene objects programmatically
- Added ability to change default and selection colors
- Added ability to fit viewport to any 3D bounding box
- Documentation:
  * Added page with 'notes' example demonstration
  * Added documentation generation for interfaces
- Examples:
  * Added 'notes' example, which demonstrates how enable interactive notes in 3D view

### Bug fixes

- Fixed 'cameraChange' event dispatching

## CAD Exchanger Web Toolkit 1.1.13, February 17, 2021

### Features

- Added Base_Uuid class
- Examples:
  * Added ASP.NET Core example

### Bug fixes

- Fixed typescript definitions

## CAD Exchanger Web Toolkit 1.1.12, July 5, 2020

### Features

- Added tutorial
- Documentation:
  * Changed format from jsdoc to doxygen

### Bug fixes

- Fixed canvas position and resizing
- Fixed typescript definitions

## CAD Exchanger Web Toolkit 1.1.11, May 26, 2020

### Features

- Documentation:
  * Added page with React.js example demonstration
- Examples:
  * Added React.js example, which demonstrates how integrate Web Toolkit into ReactJS-based application

## CAD Exchanger Web Toolkit 1.1.10, March 3, 2020

### Features

- Documentation:
  * Added page with 'measurements' example demonstration
  * Added page with 'tree-view' example demonstration
- Examples:
  * Added 'measurements' example, which demonstrates how to create measurements (distances and angles) between selected elements
  * Added 'tree-view' examplem which demonstrates how to display model structure using jsTree library

### Bug fixes

- Fixed sub-shape selection detection
- Examples:
  * Fixed 'selection' example

## CAD Exchanger Web Toolkit 1.1.9, November 6, 2019

### Features

- Added ability to automatically resize viewport when page size changed
- Added specific three.js library with converters to THREE.js entities
- Examples:
  * Added ability to change 3D model via drop down
  * Added ability to see example's source code from browser
  * Refactored three.js example to use three.js-specific library
  * Refactored examples to be more short and clear

## CAD Exchanger Web Toolkit 1.1.8, August 21, 2019

- Minor fixes and improvements

## CAD Exchanger Web Toolkit 1.1.7, July 15, 2019

### Bug fixes

- Fixed insensitive corners of view cube

## CAD Exchanger Web Toolkit 1.1.6, June 10, 2019

### Features

- Added textures support

## CAD Exchanger Web Toolkit 1.1.5, March 15, 2019

### Features

- Added PMI graphical support
- Added visitor support
- Added typescript definitions
- Added toString method for POD types (like Point, Color, etc.)
- Extended ModelData_Plane class to be like in C++ SDK
- Examples:
  * Added 'Model explorer' example, which demonstrates retrieval of data from the 3D model, including custom properties and triangles
  * Added '3D viewer' example, which demonstrates key functionality of the web viewer
  * Added 'PMI viewer' example, which demonstrates how to display graphical PMI (Product and Manufacturing Information)
  * Added 'Three.js viewer' example, which demonstrates how to visualization 3D model using pure three.js library
- Split library to core and full versions
- Ported to the three.js r102

### Bug fixes

- Fixed documentation: added 'cadex' namespace
- Fixed keyboard support: not it works only when canvas is in focus
- Fixed stack overflow when displayed object with empty bounding box

## CAD Exchanger Web Toolkit 1.1.4, February 08, 2019

### Bug fixes

- Fixed clip plane arrow size: now it can be decrease up to 0.01

## CAD Exchanger Web Toolkit 1.1.3, December 18, 2018

### Features

- Added angle dimension object
- Added units support for dimension objects
- Added interactive clip planes support
- Added hover support
- Improved example to change displayed model dynamically (by url parameters)

### Bug fixes

- Fixed rendering pipeline to speed up frame rendering
